package ssview;

import java.awt.*;
import java.io.*;
import java.awt.image.*;
import java.awt.geom.*;
import java.util.*;

import javax.swing.*;

import jimage.DrawObject;
import jimage.DrawObjectCollection;
import jimage.DrawObjectLeafNode;
import jimage.DrawParallelogramObject;

import util.*;
import util.math.BRectangle2D;

// currently holds SSData2Ds

public class
ComplexSSDataCollection2D
extends ComplexSSDataCollection
{

public
ComplexSSDataCollection2D()
{
	super();
}

public
ComplexSSDataCollection2D(String name, String author)
{
	super(name, author);
}

public
ComplexSSDataCollection2D(String name)
{
	super(name);
}

/*
public
ComplexSSDataCollection2D(String name, SSData sstr)
throws Exception
{
	super(name, sstr);
}
*/

public
ComplexSSDataCollection2D(String name, NucCollection2D nucCollection)
throws Exception
{
	super(name, nucCollection);
}

public void
setNewSSComplexElement(SSData2D newSSData)
throws Exception
{
	// first check if newSSData is already in
	for(int complexItemID = 0;complexItemID < this.getItemCount();complexItemID++)
	{
		Object complexElement = this.getItemAt(complexItemID);
		if (complexElement instanceof SSData2D)
		{
			SSData2D ssData = (SSData2D)complexElement;
			if(ssData.getName().equals(newSSData.getName()))
				throw new Exception("Error in Complex.setNewSSComlexElement: " +
					newSSData.getName() + " is already in Complex");
		}
	}
	this.setCurrentSSData(newSSData);
	addItem(this.getCurrentSSData());
}

public void
clearAnnotations()
throws Exception
{
	for (int objID = 0;objID < this.getItemCount();objID++)
	{
		Object obj = this.getItemAt(objID);
		if (obj == null)
			continue;
		if (!(obj instanceof SSData2D))
			continue;
		((SSData2D)obj).clearAnnotations();
	}
}

public void
setSymbols(Object drawObject)
throws Exception
{
	for (int objID = 0;objID < this.getItemCount();objID++)
	{
		Object obj = this.getItemAt(objID);
		if (obj == null)
			continue;
		if (!(obj instanceof SSData2D))
			continue;
		((SSData2D)obj).setSymbols(drawObject);
	}
}

public void
setFonts(Font font)
throws Exception
{
	for (int objID = 0;objID < this.getItemCount();objID++)
	{
		Object obj = this.getItemAt(objID);
		if (obj == null)
			continue;
		if (!(obj instanceof SSData2D))
			continue;
		((SSData2D)obj).setFonts(font);
	}
}

public void
runSetIsNucPath(boolean isNucPath, double pathWidth, Color color)
throws Exception
{
	for (int objID = 0;objID < this.getItemCount();objID++)
	{
		Object obj = this.getItemAt(objID);
		if (obj == null)
			continue;
		if (!(obj instanceof SSData2D))
			continue;
		((SSData2D)obj).runSetIsNucPath(isNucPath, pathWidth, color);
	}
}

/*
public Nuc2D
BAD_findNuc(double xPos, double yPos)
throws Exception
{
	for (int objID = 0;objID < this.getItemCount();objID++)
	{
		Object obj = this.getItemAt(objID);
		if (obj == null)
			continue;
		if (!(obj instanceof SSData2D))
			continue;
		Nuc2D nuc = ((SSData2D)obj).findNuc(xPos, yPos);
		if (nuc != null)
			return (nuc);
	}

	return (null);
}
*/

public static ComplexScene2D
getNewPartitionedComplexScene(SSData2D sstr, int nucID0, int nucID1)
throws Exception
{
	return (getNewPartitionedComplexScene(sstr, sstr.getNuc2DAt(nucID0),
		sstr.getNuc2DAt(nucID1)));
}

public static ComplexScene2D
getNewPartitionedComplexScene(SSData2D sstr, Nuc2D firstListNuc, Nuc2D secondListNuc)
throws Exception
{
	Vector partitionList = sstr.partitionSSData(firstListNuc, secondListNuc);

	if ((partitionList == null) || (partitionList.size() <= 1) ||
		(partitionList.size() > 3)) // MAYBE allow for > 3 later
		return (null);

	ComplexScene2D complexScene = new ComplexScene2D("testScene");
	ComplexSSDataCollection2D complexSSDataCollection =
		new ComplexSSDataCollection2D("testStr");
	

	ComplexSSDataCollection2D parentSSData2DCollection =
		(ComplexSSDataCollection2D)sstr.getParentCollection();
	for (int objID = 0;objID < parentSSData2DCollection.getItemCount();objID++)
	{
		Object obj = parentSSData2DCollection.getItemAt(objID);
		if ((obj == null) || !(obj instanceof SSData2D))
			continue;
		SSData2D tmpSStr = (SSData2D)obj;
		if (tmpSStr.getName().equals(sstr.getName()))
			continue;
		complexSSDataCollection.addItem(tmpSStr);
	}

	complexSSDataCollection.addItem((SSData2D)partitionList.elementAt(0));
	complexSSDataCollection.addItem((SSData2D)partitionList.elementAt(1));
	if (partitionList.size() == 3)
		complexSSDataCollection.addItem((SSData2D)partitionList.elementAt(2));
	complexScene.addItem(complexSSDataCollection);

	complexScene.resetNucNumbers();


	/*
	SSData2D testSStr = (SSData2D)complexSSDataCollection.getItemAt(0);
	debug("HEREERE sstr0: " + testSStr.getName() + " " + testSStr.getNucCount());
	testSStr = (SSData2D)complexSSDataCollection.getItemAt(1);
	debug("HEREERE sstr1: " + testSStr.getName() + " " + testSStr.getNucCount());
	testSStr = (SSData2D)complexSSDataCollection.getItemAt(2);
	debug("HEREERE sstr2: " + testSStr.getName() + " " + testSStr.getNucCount());
	*/


	return (complexScene);
}

public void
resetNucNumbers()
throws Exception
{
	/*
	debug("BEFORE:");
	for (int complexItemID = 0;complexItemID < this.getItemCount();complexItemID++)
	{
		Object complexElement = this.getItemAt(complexItemID);
		if (!(complexElement instanceof SSData2D))
			continue;
		SSData2D sstr = (SSData2D)complexElement;
		for (int nucID = 1;nucID <= sstr.getNucCount();nucID++)
		{
			Nuc2D nuc = sstr.getNuc2DAt(nucID);
			// if (nuc == null)
				// continue;
			System.out.println(sstr.getName() + " : " + nucID + " : " + nuc);
		}
	}
	*/

	for (int complexItemID = 0;complexItemID < this.getItemCount();complexItemID++)
	{
		Object complexElement = this.getItemAt(complexItemID);
		if (!(complexElement instanceof SSData2D))
			continue;
		SSData2D sstr = (SSData2D)complexElement;
		if (sstr.getNuc2DAt(1) != null)
			continue;

		// now find first non-null nuc
		int firstNonNullNucID = 0;
		for (firstNonNullNucID = 1;
			firstNonNullNucID <= sstr.getNucCount();firstNonNullNucID++)
		{
			Nuc2D nuc = sstr.getNuc2DAt(firstNonNullNucID);
			if (nuc != null)
				break;
		}

		int resetNucID = 0;
		for (int nucID = firstNonNullNucID;nucID <= sstr.getNucCount();nucID++)
		{
			resetNucID++;
			Nuc2D nuc = sstr.getNuc2DAt(nucID);
			if (nuc != null)
				nuc.setID(resetNucID);
			((Vector)sstr.getCollection()).set(resetNucID - 1, nuc);
		}
		for (int nucID = resetNucID + 1;nucID <= sstr.getNucCount();nucID++)
			((Vector)sstr.getCollection()).set(nucID - 1, null);
		((Vector)sstr.getCollection()).setSize(resetNucID);
		((Vector)sstr.getCollection()).trimToSize();

		// now reset basepair IDs
		for (int nucID = 1;nucID <= sstr.getNucCount();nucID++)
		{
			Nuc2D nuc = sstr.getNuc2DAt(nucID);

			if (!nuc.isBasePair())
				continue;

			nuc.getBasePair().setBasePairID(nucID);
			if (!((NucCollection2D)nuc.getBasePair().getParentCollection()).getName().equals(((NucCollection2D)nuc.getParentCollection()).getName()))
				nuc.setBasePairSStrName(((NucCollection2D)nuc.getBasePair().getParentCollection()).getName());
		}

		sstr.setSSBPNucs();
	}

	/*
	debug("AFTER:");
	for (int complexItemID = 0;complexItemID < this.getItemCount();complexItemID++)
	{
		Object complexElement = this.getItemAt(complexItemID);
		if (!(complexElement instanceof SSData2D))
			continue;
		SSData2D sstr = (SSData2D)complexElement;
		for (int nucID = 1;nucID <= sstr.getNucCount();nucID++)
		{
			Nuc2D nuc = sstr.getNuc2DAt(nucID);
			// if (nuc == null)
				// continue;
			System.out.println(sstr.getName() + " : " + nucID + " : " + nuc);
		}
	}
	*/
}

public void
printComplexXML(PrintWriter outFile)
throws Exception
{
	PrintWriter out = (PrintWriter)outFile;	

	String tabSpaces = "    ";
	out.print("<Complex Name='" + this.getName());
	if (this.getAuthor() != null)
		out.print("' Author='" + this.getAuthor());
	out.println("'>");
	// NEED to check if none 0.0,0.0 before printing
	if ((this.getX() != 0.0) || (this.getY() != 0.0))
		out.println(tabSpaces + "<SceneNodeGeom CenterX='" +
			StringUtil.roundStrVal(this.getX(), 2) + "' CenterY='" +
			StringUtil.roundStrVal(this.getY(), 2) + "' />");
	
	printLabelList(out);

	Object complexList = null;
	for(int complexItemID = 0;complexItemID < this.getItemCount();complexItemID++)
		((ComplexCollection)this.getItemAt(complexItemID)).printComplexXML(out);

	out.println("</Complex>");
}

public ComplexScene2D
wrapInComplexScene2D(String name)
throws Exception
{
	ComplexScene2D complexScene = new ComplexScene2D(name);
	complexScene.addItem(this);
	return (complexScene);
}

/*************** Draw Object Implementation *******************/

public void
setColor(Color color)
throws Exception
{
	for(int complexItemID = 0;complexItemID < this.getItemCount();complexItemID++)
		((DrawObject)this.getItemAt(complexItemID)).setColor(color);
}

public void
update(Graphics2D g2)
throws Exception
{
	BRectangle2D rect = null;

	for(int complexItemID = 0;complexItemID < this.getItemCount();complexItemID++)
	{
		Object complexElement = this.getItemAt(complexItemID);
		DrawObject drawObject = (DrawObject)complexElement;
		drawObject.update(g2);
		/*
		debug("DRWOBJ: " + drawObject.toString());
		debug("ADDING BBOX: " + drawObject.getBoundingBox());
		*/
		if (rect == null)
		{
			rect = new BRectangle2D();
			rect.setRect(drawObject.getBoundingBox());
		}
		else
		{
			rect.add(drawObject.getBoundingBox());
		}
	}

	if (this.getLabelList() != null)
	{
		for (Enumeration e = getLabelList().elements();e.hasMoreElements();)
		{
			DrawObject drawObject = (DrawObject)e.nextElement();
			drawObject.update(g2);	
			/*
			if (drawObject instanceof DrawParallelogramObject)
				debug("PARALLEL.BB: " + drawObject.getBoundingBox());
			*/
			if (rect == null)
			{
				rect = new BRectangle2D();
				rect.setRect(drawObject.getBoundingBox());
			}
			else
			{
				rect.add(drawObject.getBoundingBox());
			}
		}
	}

	BRectangle2D newRect = new BRectangle2D(
		rect.getX() + this.getX(),
		rect.getY() - this.getY(),
		rect.getWidth(),
		rect.getHeight());
	
	this.setBoundingBox(newRect);
	this.setBoundingShape(this.getBoundingBox());
}

public void
draw(Graphics2D g2, BRectangle2D constrainedArea)
throws Exception
{
	if (this.getIsHidden())
		return;
	if (this.getHideForConstrain())
		return;
	
	if (constrainedArea != null)
	{
		if (!this.intersects(constrainedArea, g2))
			return;
		// debug("IN ComplexSSDataCollection2D " + this.getName() + ", intersects");
	}

	g2.translate(this.getX(), -this.getY());
	this.setG2Transform(g2.getTransform());
	
	for(int complexItemID = 0;complexItemID < this.getItemCount();complexItemID++)
		((DrawObject)this.getItemAt(complexItemID)).draw(g2, constrainedArea);

	this.drawLabelList(g2, constrainedArea);

	g2.translate(-this.getX(), this.getY());

	if (this.getShowBoundingShape())
	{
		g2.setColor(Color.magenta);
		this.drawBoundingShape(g2);
	}
}

public void
printPS(Graphics2D g2, PostScriptUtil psUtil)
throws Exception
{
	if (this.getIsHidden())
		return;
	
	psUtil.printPSGSave();
	g2.translate(this.getX(), this.getY());
	this.setG2Transform(g2.getTransform());
	
	for(int complexItemID = 0;complexItemID < this.getItemCount();complexItemID++)
		((DrawObject)this.getItemAt(complexItemID)).printPS(g2, psUtil);

	this.printPSLabelList(g2, psUtil);
	psUtil.printPSGRestore();

	g2.translate(-this.getX(), this.getY());

	/*
	if (this.getShowBoundingShape())
	{
		g2.setColor(Color.magenta);
		this.drawBoundingShape(g2);
	}
	*/
}

public void
erase(Graphics2D g2)
throws Exception
{
	for(int complexItemID = 0;complexItemID < this.getItemCount();complexItemID++)
		((DrawObject)this.getItemAt(complexItemID)).erase(g2);

	if (this.getLabelList() != null)
		for (Enumeration e = getLabelList().elements();e.hasMoreElements();)
			((DrawObject)e.nextElement()).erase(g2);
}

public static void
debug(String s)
{
	System.err.println("ComplexSSDataCollection2D-> " + s);
}

}
